<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        See ibex.widget.cardpane for details

        <todo>
            Make cardpane aware of 'enabled' cards
        </todo>
    </meta:doc>
 
    <ui:box>

        // public interface

        thisbox.nextcard;
        thisbox.nextstep;
        thisbox.prevcard;
        thisbox.prevstep;
        thisbox.show;

        // private variables

        var steps = [];
        var stepmarker = 0;
        var stepping = false;

        // childadded write trap
        childadded ++= function(v) {
            // show v if it is the first card
            if (numchildren > 1) v.visible = false;
            else { cascade = v; show = v; }
        }

        // childremoved write trap
        childremoved ++= function(v) {
            // if v is the shown card, attempt to show another
            if (show == v) {
                if (next) next = true;
                else if (prev) prev = true;
            }
        }

        // write trap to show the next card in the cardpane
        nextcard ++= function(v) {
            if (nextcard) nextcard.show = true;
        }

        // read trap to fetch the next card in the cardpane
        nextcard ++= function() {
            if (show and numchildren - 1 > show) return thisbox[show + 1];
            else return null;
        }

        // write trap to step forward to the next in the show-chain
        nextstep ++= function(v) {
            stepping = true;
            if (nextstep) nextstep.show = true;
            stepping = false;
        }

        // read trap to fetch the next step in the show-chain
        nextstep ++= function() {
            if (steps.length - 1 > stepmarker) return steps[stepmarker + 1];
            else return false;
        }

        // write trap to show the previous card in the cardpane
        prevcard ++= function(v) {
            if (prevcard) prevcard.show = true;
        }

        // read trap to fetch the previous card in the cardpane
        prevcard ++= function() {
            if (show and show > 0) return thisbox[show - 1];
            else return false;
        }

        // write trap to step back to the previous in the show-chain
        prevstep ++= function(v) {
            stepping = true;
            if (prevstep) prevstep.show = true;
            stepping = false;
        }

        // read trap to fetch the previous step in the show-chain
        prevstep ++= function() {
            if (stepmarker > 0) return steps[stepmarker - 1];
            else return false;
        }

        // write trap to show a card by box or index
        show ++= function(v) {
            var card;
            
            if (typeof(v) == "number" and numchildren > v) card = thisbox[v];
            else if (typeof(v) == "object" and (thisbox.indexof(v) or thisbox.indexof(v) == 0)) card = v;

            if (card) {
                // hide the previously shown card and show the new one
                //if (cascade) cascade.visible = false;
                for (var i=0; numchildren > i; i++) { thisbox[i].visible = false; }
                card.visible = true;

                // remember where we are
                if (!stepping) {
                    stepmarker ++;
                    if (stepmarker != steps.length) steps.splice(stepmarker, steps.length - stepsmarker);
                    if (stepmarker > 100) steps.splice(0);
                    steps[stepmarker] = card;
                }

                cascade = card;
            }
            else return;
        }

    </ui:box>
</ibex>
