<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        See ibex.theme.clickable for details
    </meta:doc>

    <ibex.lib.repeatable />
    <ui:box>

        // template properties
        thisbox.enabled;    // self explanatory
        thisbox.repeats;    // if a repeating action is desired

        // event triggers
        thisbox.action;     // action trigger

        // state properties
        thisbox.primed;     // track activation irrespective of mouse.inside

        // physical state triggers
        thisbox.active;     // active state (mouse.inside and primed)
        thisbox.hover;      // hover state (mouse.inside and !primed)
        thisbox.normal;     // normal state (!mouse.inside)

        enabled ++= function(v) {
            cascade = v;
            // deprime us when disabled
            if (!v) { primed = false; normal = true; }
        }

        focused ++= function(v) {
            cascade = v;
            // unprime if defocused
            if (!v and primed) primed = false;
        }

        primed ++= function(v) {
            if (enabled) {
                // determine physical state and activate trigger
                v ? active = true : (mouse.inside ? hover = true : normal = true);
                // set repeat state if necessary
                if (repeats) repeat = v;
            }
            // do nothing when not enabled
            else cascade = false;
        }

        KeyPressed ++= function(v) {
            if (v == "enter" or v == " ") primed = true;
            else if (v == "escape") primed = false;
        }

        KeyReleased ++= function(v) {
            if (v == "enter" or v == " ")
                if (primed and enabled)
                    { action = true; primed = false; }
        }

        Enter ++= function(v) {
            if (enabled) {
                if (primed) {
                    active = true;
                    if (repeats) repeat = true;
                }
                else hover = true;
            }
        }

        Leave ++= function(v) {
            if (enabled) {
                normal = true;
                if (repeats) repeat = false;
            }
        }

        Press1 ++= function(v) {
            if (enabled) {
                primed = true;

                surface.Release1 ++= function(v) {
                    // clean up
                    if (enabled) {
                        if (primed) {
                            if (mouse.inside) repeats ? repeat = false : action = true;
                            primed = false; // important: must occur _after_ action
                        }
                    }

                    surface.Release1 --= callee;
                }
            }
        }

        // initialise as normal state
        // FIXME: redo this using better method (?)
        SizeChange ++= function(v) {
            normal = true;
            SizeChange --= callee;
        }

    </ui:box>
</ibex>
