<!-- Copyright 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        See ibex.theme.focusable for more details

        <author>Charles Goodwin</author>
        <author>David Crawshaw</author>
    </meta:doc>

    <ui:box>

        thisbox.enabled;    // whether a focusable is enabled
        thisbox.focusable;  // whether a focusable may be focused
        thisbox.focused;    // whether a focusable is focused
        thisbox.nextfocus;  // read for the focus after thisbox on the surface
        thisbox.prevfocus;  // read for the focus before thisbox on the surface

        // private function to assign to traps
        var checkfocus = function(v) { if (!v and focused) focused = false; }

        enabled ++= checkfocus;     // disabling prevents focus
        focusable ++= checkfocus;   // making unfocusable prevents focus

        // read trap to return focusable state
        focusable ++= function() { return enabled and cascade; }

        // write trap to set focused state
        focused ++= function(v) {
            if (v and surface and focusable) {
                if (surface.focus) {
                    surface.focus.focused = false;
                }
                surface.focus = thisbox;
            }
            else if (!v and surface and surface.focus == thisbox)
                surface.focus = null;
            else cascade = false;
        }

        // read trap to return the focus after thisbox on the surface
        nextfocus ++= function() { return surface.nextFocus(thisbox); }

        // read trap to return the focus before thisbox on the surface
        prevfocus ++= function() { return surface.prevFocus(thisbox); }

        // write trap to handle surface change
        surface ++= function(v) {
            // drop from current surface if there is one
            if (cascade) cascade.dropFocus(thisbox);

            // add to new surface
            v.addFocus(thisbox);
        }

        // write trap to focus on Press1
        Press1 ++= function(v) { if (!focused and focusable) focused = true; }

    </ui:box>
</ibex>
