<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        Authors: Charles Goodwin, David Crawshaw

        For documentation, see ibex.theme.surface
    </meta:doc>

    <ui:box>

        var focus = null;   // the current focus

        // the focus list for this surface
        var fvector = ibex..ibex.util.vector..newVector();
        //var fvector = ibex..ibex.util.vector(ibex.box);

        // read trap to access the focused child
        surface.focus ++= function() { return focus; }

        surface.setFocus ++= function(v) {
            if (v and v.focusable and fvector.contains(v)) {
                if (focus and focus != v) focus.focused = false;
                return true;
            }
            else if (!v and focus) {
                focus.focused = false;
                return true;
            }
            else return false;
        }

        // function to add a focus to the focus vector, optionally after w
        surface.addFocus = function(v, w) {
            // make sure we're not already in the focus list
            surface.dropFocus(v);
            
            if (w and fvector.contains(w))
                return fvector.insert(v, w);
            else return fvector.push(v);
        }

        // function to drop a focus from the focus vector for this surface
        surface.dropFocus = function(v) {
            if (fvector.contains(v)) {
                if (focus == v) focus = v.nextfocus;
                return fvector.remove(v);
            }
            else return false;
        }

        // function to return the next-in-line for focus after v
        surface.nextFocus ++= function(v) {
            var nf = fvector.after(v);
            while (!nf.focusable and nf != v) nf = fvector.after(nf);
            return nf;
        }

        // function to return the previous-in-line for focus after v
        surface.prevFocus ++= function(v) {
            var pf = fvector.after(v);
            while (!pf.focusable and pf != v) pf = fvector.before(pf);
            return pf;
        }

        // private function to map events from this root ui:box onto the focused child
        var passEvent = function(v) { if (focus) focus[trapname] = v; }

        _KeyPressed ++= passEvent;      // pass keypress events to focused child
        _KeyReleased ++= passEvent;     // pass keyrelease events to focused child

    </ui:box>
</ibex>
