<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        See xwt.theme.redirect for details
    </meta:doc>

    <ui:box>

        var locks = {};
        var redirects = {};

        thisbox.redirectTo = function(v) {
            if (v == null) {
                ibex.log.warn("Attempted to redirect properties to a null value");
                return false;
            }

            for (var i=1; arguments.length > i; i++) {
                // get property from arguments
                var p = arguments[i];

                // remove the trap if it already exists
                if (redirects[p]) dropRedirect(v, p);

                // create and store redirecting functions
                redirects[p] = [v,
                                function(w) {
                                    if (!locks[p]) { locks[p] = true; cascade = w; thisbox[p] = w; locks[p] = null; }
                                },
                                function(w) {
                                    if (!locks[p]) { locks[p] = true; v[p] = w; locks[p] = null; }
                                    return true;
                                },
                                function() { return v[p]; }];

                // assign redirecting traps
                try { // try/catch for properties that can't have write traps
                    thisbox[p] ++= redirects[p][2];
                    v[p] ++= redirects[p][1];
                } catch(e) {
                    redirects[p][1] = null;
                    redirects[p][2] = null;
                }
                // try/catch for properties that can't have read traps
                try { thisbox[p] ++= redirects[p][3]; }
                catch(e) { redirects[p][3] = null; }
            }

            // report success
            return true;
        }

        thisbox.dropRedirect = function(v) {
            for (var i=1; arguments.length > i; i++) {
                // get property from arguments
                var p = arguments[i];

                // remove redirect traps and reference
                if (redirects[p]) {
                    if (redirects[p][1]) redirects[p][0] --= redirects[p][1];
                    if (redirects[p][2]) thisbox[p] --= redirects[p][2];
                    if (redirects[p][3]) thisbox[p] --= redirects[p][3];
                    redirects[p] = null;
                }
            }

            return true;
        }

    </ui:box>
</ibex>
