<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        Author: Charles Goodwin
    </meta:doc>

    <ui:box>

        // public variables
        thisbox.amount;
        thisbox.hide;
        thisbox.page;
        thisbox.shift;
        thisbox.slave;
        thisbox.smart;

        // theme box variables
        thisbox.th_back;
        thisbox.th_next;
        thisbox.th_thumb;
        thisbox.th_track;

        // private variables
        var listeners = {};
        var motion;
        var movefun1 = function(v) { th_thumb.action = true; }
        var movefun2 = function(v) { recall["track"] = th_track.mouse[pos]; }
        var recall = {};
        var percent;

        // attempt to shift slave by given amount
        shift ++= function(v) {
            motion = true;
            slave[0][pos] = ibex.math.min(0, ibex.math.max(slave[dim] - slave[0][dim], slave[0][pos] - v));
            syncThumb();
            motion = false;
        }

        // set up slave
        slave ++= function(v) {
            v.SizeChange ++= slaveFunc;
            v[0].PosChange ++= slaveFunc;
            v[0].SizeChange ++= slaveFunc;

            cascade = v;
            syncThumb();
        }

        smart ++= function(v) { cascade = v; syncThumb(); }

        th_back ++= function(v) { v.action ++= function(w) { shift = -1*amount; } }
        th_next ++= function(v) { v.action ++= function(w) { shift = amount; } }

        th_track ++= function(v) {
            v.action ++= function(w) {
                if (th_thumb[pos] > recall["track"]) shift = -1*page;
                else if (recall["track"] > th_thumb[pos] + th_thumb[dim]) shift = page; 
            }

            v.repeat ++= function(w) {
                if (w) { Move ++= movefun2; movefun2(); }
                else { Move --= movefun2; recall["track"] = null; }
            }

            v.SizeChange ++= function(w) { syncThumb(); }
        }

        th_thumb ++= function(v) {
            v.action ++= function(w) {
                th_thumb[pos] = ibex.math.max(0,
                                    ibex.math.min(th_track[dim] - th_thumb[dim],
                                        recall["thumb"] + (surface.mouse[pos] - recall["start"])));
                syncSlave();
            }

            v.Press1 ++= function(w) {
                motion = true;
                recall["start"] = surface.mouse[pos];
                recall["thumb"] = th_thumb[pos];
                surface.Move ++= movefun1;
                surface.Release1 ++= function(w) {
                    motion = false;
                    surface.Move --= movefun1;
                    surface.Release1 --= callee;
                }
            }
        }

        // public functions

        thisbox.addListener = function(v) {
            listeners[v] = [v, v[0]];
            v.SizeChange ++= listenerFunc;
            v[0].PosChange ++= listenerFunc;
            v[0].SizeChange ++= listenerFunc;
            syncAllListeners();
        }

        thisbox.removeListener = function(v) {
            if (listeners[v] != null) {
                listeners[v][0].SizeChange --= listenerFunc;
                listeners[v][1].PosChange --= listenerFunc;
                listeners[v][1].SizeChange --= listenerFunc;
                listeners[v] = null;
            }
        }

        // sync functions

        var syncAllListeners = function(v) {
            if (motion) {
                for (key in listeners) {
                    if (v == listeners[key][0]) continue;
                    syncListener(listeners[key][0]);
                }
            }
        }

        var syncListener = function(v) {
            percent = slave[0][pos] / (slave[dim] - slave[0][dim]);
            if (v and v[0]) v[0][pos] = percent * (v[dim] - v[0][dim]);
        }

        var syncSlave = function() {
            if (slave) {
                percent = th_thumb[pos] / (th_track[dim] - th_thumb[dim]);
                slave[0][pos] = percent * (slave[dim] - slave[0][dim]);
            }
        }

        var syncThumb = function() {
            if (slave == null || slave[0] == null || slave[dim] >= slave[0][dim]) {
                if (enabled) enabled = false;
                th_thumb[dim] = th_track[dim];
                th_thumb[pos] = 0;
            }
            else {
                if (!enabled) enabled = true;
                th_thumb[dim] = ibex.math.min(th_track[dim], (slave[dim] / slave[0][dim]) * th_track[dim]);
                percent = slave[0][pos] / (slave[dim] - slave[0][dim]);
                th_thumb[pos] = ibex.math.max(0, (th_track[dim] - th_thumb[dim]) * percent);
            }
        }

        // reusable functions

        var listenerFunc = function(v) {
            if (!motion and trapee.constrain) {
                motion = true;
                syncAllListeners(trapee);
                syncSlave();
                motion = false;
            }
        }

        var slaveFunc = function(v) {
            if (!motion) {
                motion = true;
                syncThumb();
                syncAllListeners();
                motion = false;
            }
        }

    </ui:box>
</ibex>
