<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        Author: Charles Goodwin

        See ibex.theme.selectable for documentation

        TODO:
            1..n selection model with rolling selection
    </meta:doc>

    // static content

    var groups = {};    // the groups of selectables

    static.toGroup = function(v, oldg, g) {

        // no group given, create group
        if (3 > arguments.length) {
            g = { members : (ibex..ibex.util.vector..newVector(v)),
                  selected : null, selection : [] };
            //groups[g] = g;
            groups[g] = g;
        }
        // validate group
        else if (g and groups[g] != g) {
            ibex.log.warn("Invalid group passed to toGroup: " + g + " " + groups[g]);
            return oldg;
        }

        // remove v from oldg
        if (oldg and g != oldg) {
            oldg.members.remove(v);

            // clean up group info
            if (oldg.selection[v]) v.selected = false;

            // clean up groups list
            if (!oldg.members.length) groups[oldg] = null;
        }

        // add to group
        if (g) {
            if (g != oldg) g.members.push(v);
            return g;
        }
        else return null;
    }

    // end of static content

    <ui:box>

        thisbox.mixed;      // mixed status
        thisbox.nextselect; // next group member to select
        thisbox.prevselect; // previous group member to select
        thisbox.selected;   // selection status

        var groupref;       // internal reference to group

        // group read trap
        thisbox.group ++= function() {
            // if no group, get one
            if (!groupref) groupref = static.toGroup(thisbox);
            return groupref;
        }

        // group write trap
        thisbox.group ++= function(v) {
            // add us to group v
            groupref = static.toGroup(thisbox, groupref, v);
        }

        // selected read trap
        thisbox.selected ++= function() {
            if (mixed) return true;
            else return cascade;
        }

        // selected write trap
        thisbox.selected ++= function(v) {
            if (groupref) {
                if (v) {
                    if (groupref.selected != thisbox) {
                        if (groupref.selected) groupref.selected.selected = false;
                        groupref.selected = thisbox;
                    }
                }
                else if (groupref.selected == thisbox) groupref.selected = null;
            }
        }

        // find the next selectable member
        thisbox.nextselect ++= function() {
            var ns = thisbox;
            do {
                ns = groupref.members.after(ns);
                if (!ns) ns = groupref.members.first;
            } while (!ns.enabled and ns != thisbox);
            
            return ns.enabled ? ns : null;
        }

        // find the previous selectable member
        thisbox.prevselect ++= function() {
            var ps = thisbox;
            do {
                ps = groupref.members.before(ps);
                if (!ps) ps = groupref.members.last;
            } while (!ps.enabled and ps != thisbox);

            return ps.enabled ? ps : null;
        }

        // integration with clickable
        action ++= function(v) { selected = true; }

        // integration with clickable and focusable
        focusable ++= function() { return cascade and (primed or selected); }

        // integration with focusable
        nextfocus ++= function() {
            var nf = cascade;
            while (nf.group == groupref and nf != thisbox) nf = cascade;
            return nf;
        }

        // integration with focusable
        prevfocus ++= function() {
            var pf = cascade;
            while (pf.group == groupref and pf != thisbox) pf = cascade;
            return pf;
        }

    </ui:box>
</ibex>
