<!-- Copyright 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        Author: Charles Goodwin
    </meta:doc>

    <ui:box>

        // public variables

        thisbox.interval;   // user defined interval between steps
        thisbox.lowerlimit; // the lower limit of the value range
        thisbox.upperlimit; // the upper limit of the value range
        thisbox.step;       // the current step (integer)
        thisbox.value;      // the current value

        // theme box traps

        thisbox.th_track;   // the track in which the slider runs
        thisbox.th_handle;  // the slider handle

        // private variables

        var numsteps;       // the number of steps

        // write trap adjust the step according to the mouse position
        action ++= function(v) {
            step = ibex.math.round(numsteps * (track[mousepos] - handle[dim] / 2) / (track[dim] - handle[dim]));
        }

        var synclimits = function(v) {
            cascade = v;

            // we need all of the following to be set
            if (interval == null || lowerlimit == null || upperlimit == null) return;

            // interval should to be a factor of (upperlimit - lowerlimit)
            if ((upperlimit - lowerlimit) % interval)
                ibex.println("WARNING: limit difference is not divisible by interval");
 
            // work out the number of steps
            numsteps = (upperlimit - lowerlimit) / interval;
        }

        interval ++= synclimits;
        lowerlimit ++= synclimits;
        upperlimit ++= synclimits;

        orient ++= function(v) {
            arguments.cascade(v);
            track[mindim] = 0;
            track[flip(mindim)] = handle[flip(dim)];
        }

        step ++= function(v) {
            // make sure step has a valid value
            arguments.cascade((0 > v) ? 0 : (v > numsteps) ? numsteps : v);
            // adjust the handle position according to the step
            handle[pos] = step * (track[dim] - handle[dim]) / numsteps;
        }

        // read trap to return value based on current step
        value ++= function() {
            return ibex.math.min(lowerlimit + step * interval, upperlimit);
        }

        // write trap to set the step according to the given value
        value ++= function(v) {
            step = ibex.math.round((v - lowerlimit) / interval);
        }

        // theme box traps

        handle ++= function(v) {
            // always absolute so we can be moved
            v.packed = false;

            // make sure the widget always has the correct flip(dim)
            v.SizeChange ++= function(v) {
                track[flip(dim)] = handle[flip(dim)];
            }
        }

        KeyPressed ++= function(v) {
            if (v == "left" or v == "down") step -= 1;
            else if (v == "right" or v == "up") step += 1;
        }

        Press1 ++= function(v) {
            // activate the slider handle
            var shift = surface.addEvent("_Move", thisbox, "Move");

            /* argh what to do? */
            if (root.Move == null) {
                action = true;
                root.Move = function() { action = true; }
                root.Release1 = function() { root._Move = null; root._Release1 = null; }
            }
        }

    </ui:box>
</ibex>
