<!-- Copyleft 2004 - see COPYING for details [LGPL] -->

<ibex>
    <meta:doc>
        Author: Charles Goodwin

        TODO:
            Add move(v) function
    </meta:doc>

    // start of static content

    newVector = function(v) {
        var new_vec = ibex.box;
        ibex..ibex.util.vector(new_vec);
        if (v) new_vec.push(v);
        return new_vec;
    }

    // end of static content

    <ui:box>

        var elements = {};  // hash containing all our elements
        var obj1;           // the first (#1) object in elements
        var objn;           // the nth (last) object in elements
        var count = 0;      // counts the number of elements

        // private function to add to an empty elements
        var addtoempty = function(v) {
            elements[v] = { self: v };
            obj1 = objn = v;
            ++count;
            return true;
        }

        // private function to leave elements empty
        var makesempty = function(v) {
            elements[v] = null;
            obj1 = objn = null;
            --count;
            return true;
        }

        // read trap to return the first object in elements
        thisbox.first ++= function() { return obj1; }

        // read trap to return the last object in elements
        thisbox.last ++= function() { return objn; }

        // read trap to return the length of elements
        thisbox.length ++= function() { return count; }

        // function to return the object after v in elements
        thisbox.after = function(v) { return elements[v].next ? elements[v].next.self : null; }

        // function to return the object before v in elements
        thisbox.before = function(v) { return elements[v].prev ? elements[v].prev.self : null; }

        // function to check where elements contains v
        thisbox.contains = function(v) { return elements[v] ? true : false; }

        // function to insert v optionally after w
        thisbox.insert = function(v, w) {
            if (arguments.length == 1) return push(v);
            else if (!elements[v] and elements[w]) {
                elements[v] = { next: elements[w].next, prev: w, self: v };
                elements[elements[w].next].prev = v;
                elements[w].next = v;
                ++count;
                return true;
            }
            else return false;
        }

        // function to remove v
        thisbox.remove = function(v) {
            if (elements[v]) {
                if (count == 1) return makesempty(v);
                else {
                    elements[elements[v].prev].next = elements[v].next;
                    elements[elements[v].next].prev = elements[v].prev;
                    elements[v] = null;
                    --count;
                    return true;
                }
            }
            else return false;
        }

        // function to pop last object from elements
        thisbox.pop = function() {
            if (count == 1) return makesempty(objn);
            else if (count) {
                var drop = objn;
                elements[elements[objn].prev].next = null;
                elements[drop] = null;
                objn = elements[elements[drop].prev].self;
                --count;
                return drop;
            }
            else return null;
        }

        // function to push v onto the end of elements
        thisbox.push = function(v) {
            if (!count) return addtoempty(v);
            else if (!elements[v]) {
                elements[v] = { prev: elements[objn], self: v };
                elements[objn].next = elements[v];
                objn = v;
                ++count;
                return true;
            }
            return false;
        }

        // function to shift first object from elements
        thisbox.shift = function() {
            if (count == 1) return makesempty(obj1);
            else if (count) {
                var drop = obj1;
                elements[elements[drop].next].prev = null;
                elements[drop] = null;
                obj1 = elements[elements[drop].next].self;
                --count;
                return drop;
            }
            else return null;
        }

        // function to unshfit v onto the front of elements
        thisbox.unshift = function(v) {
            if (!count) return addtoempty(v);
            else if (!elements[v]) {
                elements[v] = { next: elements[obj1], self: v };
                elements[obj1].prev = elements[v];
                obj1 = v;
                ++count;
                return true;
            }
            else return false;
        }

    </ui:box>
</ibex>
