<ibex xmlns:theme="ibex.theme" xmlns="ibex.widget">
    <theme:surface />
    <ui:box cols="1" fill="#d4d0c8" maxwidth="400" maxheight="300">

        ibex.ui.frame = thisbox;

        // $r4.group = $r3.group = $r2.group = $r1.group;
        $r2.group = $r1.group;
        $r3.group = $r1.group;
        $r4.group = $r1.group;

        $bg.fill ++= function(v) {
            cascade = v;
            if (v == "white") $r1.selected = true;
            else if (v == "red") $r2.selected = true;
            else if (v == "green") $r3.selected = true;
            else if (v == "blue") $r4.selected = true;
            else if (v == null and $r1.group.selected) $r1.group.selected.selected = false;
        }

        $b1.action ++= function(v) {
            if ($r1.group.selected and $r1.group.selected.nextselect)
                $r1.group.selected.nextselect.selected = true;
            else for (var i=0; $radios.numchildren > i; i++)
                if ($radios[i].enabled) { $radios[i].selected = true; break; }
        }
        
        $b2.action ++= function(v) {
            var targets = [];
            for (var i=0; 4 > i; i++) if ($radios[i].enabled) targets[targets.length] = $radios[i];

            if (targets.length > 0) {
                var n = ibex.math.floor(targets.length * ibex.math.random());
                targets[n].selected = true;
            }
            else ibex.log.info("No enabled colors to choose from!");
        }

        $b3.action ++= function(v) { $bg.fill = null; }

        $c1.selected ++= function(v) { $r1.enabled = !v; }
        $c2.selected ++= function(v) { $r2.enabled = !v; }
        $c3.selected ++= function(v) { $r3.enabled = !v; }
        $c4.selected ++= function(v) { $r4.enabled = !v; }

        $r1.selected ++= function(v) { if (v and $bg.fill != "#ffffff") $bg.fill = "white"; }
        $r2.selected ++= function(v) { if (v and $bg.fill != "#ff0000") $bg.fill = "red"; }
        $r3.selected ++= function(v) { if (v and $bg.fill != "#008000") $bg.fill = "green"; }
        $r4.selected ++= function(v) { if (v and $bg.fill != "#0000ff") $bg.fill = "blue"; }

        <ui:box>
            <ui:box id="buttons" cols="1">
                <button id="b1" margin="10 5 0 5" text="cycle" />
                <button id="b2" margin="10 5 0 5" text="random" />
                <button id="b3" margin="10 5 0 5" text="reset" />
            </ui:box>

            <ui:box id="checks" cols="1">
                <check id="c1" margin="10 5 0 5" text="disable white button" />
                <check id="c2" margin="10 5 0 5" text="disable red button" />
                <check id="c3" margin="10 5 0 5" text="disable green button" />
                <check id="c4" margin="10 5 0 5" text="disable blue button" />
            </ui:box>
 
            <ui:box id="radios" cols="1">
                <radio id="r1" margin="10 5 0 5" text="white bg" />
                <radio id="r2" margin="10 5 0 5" text="red bg" />
                <radio id="r3" margin="10 5 0 5" text="green bg" />
                <radio id="r4" margin="10 5 0 5" text="blue bg" />
            </ui:box>
        </ui:box>
        <bevel id="bg" form="down" margin="10" />
    </ui:box>
</ibex>
